__version__ = "0.2.2.1"

import pooltool.ai as ai
import pooltool.ai.aim as aim
import pooltool.ai.pot as pot
from pooltool import terminal
from pooltool.ani.animate import FrameStepper, Game, ShotViewer
from pooltool.ani.image import (
    GzipArrayImages,
    HDF5Images,
    ImageZip,
    NpyImages,
    image_stack,
    save_images,
)
from pooltool.events import (
    Agent,
    AgentType,
    Event,
    EventType,
    ball_ball_collision,
    ball_circular_cushion_collision,
    ball_linear_cushion_collision,
    ball_pocket_collision,
    filter_ball,
    filter_time,
    filter_type,
    filter_events,
    by_time,
    by_type,
    by_ball,
    null_event,
    rolling_spinning_transition,
    rolling_stationary_transition,
    sliding_rolling_transition,
    spinning_stationary_transition,
    stick_ball_collision,
)
from pooltool.evolution import continuize, simulate
from pooltool.game.datatypes import GameType
from pooltool.game.layouts import (
    get_eight_ball_rack,
    get_nine_ball_rack,
    get_rack,
    get_snooker_rack,
    get_three_cushion_rack,
)
from pooltool.game.ruleset import EightBall, NineBall, Snooker, ThreeCushion, SumToThree, get_ruleset
from pooltool.game.ruleset.datatypes import Player, Ruleset
from pooltool.objects import (
    Ball,
    BallHistory,
    BallOrientation,
    BallParams,
    BallSet,
    BallState,
    BilliardTableSpecs,
    CircularCushionSegment,
    Cue,
    CueSpecs,
    CushionDirection,
    CushionSegments,
    LinearCushionSegment,
    Pocket,
    PocketTableSpecs,
    SnookerTableSpecs,
    Table,
    TableModelDescr,
    TableType,
    get_ball_set,
)
from pooltool.physics.engine import PhysicsEngine
from pooltool.system import MultiSystem, System, SystemController, multisystem, visual

run = terminal.Run()
progress = terminal.Progress()


__all__ = [
    "get_eight_ball_rack",
    "get_nine_ball_rack",
    "get_three_cushion_rack",
    "get_snooker_rack",
    "System",
    "MultiSystem",
    "PhysicsEngine",
    "multisystem",
    "SystemController",
    "visual",
    "filter_ball",
    "filter_time",
    "filter_type",
    "filter_events",
    "by_type",
    "by_ball",
    "by_time",
    "FrameStepper",
    "null_event",
    "ball_ball_collision",
    "ball_linear_cushion_collision",
    "ball_circular_cushion_collision",
    "ball_pocket_collision",
    "stick_ball_collision",
    "spinning_stationary_transition",
    "rolling_stationary_transition",
    "rolling_spinning_transition",
    "sliding_rolling_transition",
    "GameType",
    "Event",
    "EventType",
    "AgentType",
    "Agent",
    "Ball",
    "BallSet",
    "BallState",
    "BallParams",
    "BallHistory",
    "BallOrientation",
    "CueSpecs",
    "Cue",
    "Pocket",
    "LinearCushionSegment",
    "CircularCushionSegment",
    "CushionSegments",
    "CushionDirection",
    "ImageZip",
    "HDF5Images",
    "GzipArrayImages",
    "NpyImages",
    "Table",
    "TableModelDescr",
    "TableType",
    "PocketTableSpecs",
    "BilliardTableSpecs",
    "SnookerTableSpecs",
    "Game",
    "save_images",
    "image_stack",
    "ShotViewer",
    "simulate",
    "continuize",
    "get_rack",
    "get_ruleset",
    "ThreeCushion",
    "EightBall",
    "Player",
    "NineBall",
    "Ruleset",
    "SumToThree",
    "Snooker",
    "get_ball_set",
    "ai",
    "pot",
    "aim",
]
